#include <bits/stdc++.h>
#define endl '\n'

//#pragma GCC optimize ("O3")
//#pragma GCC target ("sse4")

using namespace std;
template<class T, class T2> inline int chkmax(T &x, const T2 &y) { return x < y ? x = y, 1 : 0; }
template<class T, class T2> inline int chkmin(T &x, const T2 &y) { return x > y ? x = y, 1 : 0; }
const int MAXN = (1 << 8);

int n, dummy;
string t[MAXN], a[MAXN];

void read()
{
    cin >> n;
    for(int i = 0; i < n; i++)
        cin >> t[i];

    cin >> dummy;
}

int X, Y;
char C = 'B';
string ret;

int dx[4] = {1, 0, -1, 0};
int dy[4] = {0, 1, 0, -1};
char dc[4] = {'d', 'r', 'u', 'l'};
char dc2[4] = {'D', 'R', 'U', 'L'};

void go_keep_color(int tx, int ty)
{
    while(X != tx || Y != ty)
    {
        for(int d = 0; d < 4; d++)
            if(tx != X && abs(X + dx[d] - tx) < abs(X - tx))
            {
                ret += dc2[d];
                X += dx[d];
            }

        a[X][Y] = C;
        for(int d = 0; d < 4; d++)
            if(ty != Y && abs(Y + dy[d] - ty) < abs(Y - ty))
            {
                ret += dc2[d];
                Y += dy[d];
            }

        a[X][Y] = C;
    }
}

void go_keep_config(int tx, int ty)
{
    while(X != tx || Y != ty)
    {
        for(int d = 0; d < 4; d++)
            if(tx != X && abs(X + dx[d] - tx) < abs(X - tx))
            {
                ret += dc[d];
                X += dx[d];
            }

        for(int d = 0; d < 4; d++)
            if(ty != Y && abs(Y + dy[d] - ty) < abs(Y - ty))
            {
                ret += dc[d];
                Y += dy[d];
            }
    }

    C = a[X][Y];
}

int lx, ly, l1, l2;
int get(int x, int y) { return x * ly + y; }

pair<int, int> par[1 << 12][5][5];
char par_d[1 << 12][5][5];
int par_mask[1 << 12][5][5];

int setW(int i, int j, int mask) { int bit = get(i, j); if((mask >> bit) & 1) mask -= (1 << bit); return mask; }
int setB(int i, int j, int mask) { int bit = get(i, j); if(!((mask >> bit) & 1)) mask += (1 << bit); return mask; }
char getC(int i, int j, int mask) { int bit = get(i, j); return ((mask >> bit) & 1) ? 'B' : 'W'; }

bool is_ok(int x, int y) { return x >= 0 && y >= 0 && x < l1 && y < l2; }

void bfs(int sx, int sy, int smask, int tmask)
{
    for(int i = 0; i < (1 << (l1 * l2)); i++)
        for(int x = 0; x < l1; x++)
            for(int y = 0; y < l2; y++)
                par[i][x][y] = {-1, -1};

    par[smask][sx][sy] = {0, 0};
    queue<pair<int, pair<int, int> > > Q;
    Q.push({smask, {sx, sy}});

    while(!Q.empty())
    {
        int mask = Q.front().first;
        int x = Q.front().second.first;
        int y = Q.front().second.second;
        Q.pop();

        for(int d = 0; d < 4; d++)
        {
            int nx = x + dx[d], ny = y + dy[d];
            if(!is_ok(nx, ny)) continue;

            int nmask = mask;
            if(par[nmask][nx][ny] == make_pair(-1, -1))
            {
                par_d[nmask][nx][ny] = dc[d];
                par[nmask][nx][ny] = {x, y};
                par_mask[nmask][nx][ny] = mask;
                Q.push({nmask, {nx, ny}});
            }
        }

        for(int d = 0; d < 4; d++)
        {
            int nx = x + dx[d], ny = y + dy[d];
            if(!is_ok(nx, ny)) continue;

            char curr_c = getC(x, y, mask);

            int nmask = mask;
            if(curr_c == 'W') nmask = setW(nx, ny, mask);
            else nmask = setB(nx, ny, mask);

            if(par[nmask][nx][ny] == make_pair(-1, -1))
            {
                par_d[nmask][nx][ny] = dc2[d];
                par[nmask][nx][ny] = {x, y};
                par_mask[nmask][nx][ny] = mask;
                Q.push({nmask, {nx, ny}});
            }
        }
    }

    for(int i = 0; i < l1; i++)
        for(int j = 0; j < l2; j++)
            if(par[tmask][i][j] != make_pair(-1, -1))
            {
                C = getC(i, j, tmask);
                X = i, Y = j;

                string RRR = "";
                while(i != sx || j != sy || tmask != smask)
                {
                    int nmask = par_mask[tmask][i][j];
                    int nx = par[tmask][i][j].first;
                    int ny = par[tmask][i][j].second;
                    RRR += par_d[tmask][i][j];

                    tmask = nmask;
                    i = nx;
                    j = ny;
                }

                reverse(RRR.begin(), RRR.end());
                ret += RRR;
                return;
            }

    cout << "ERROR! : no solution for the current " << l1 << " X " << l2 << endl;
    assert(false);
}

void solve_brute(int x1, int x2, int y1, int y2)
{
    /*cout << "current rect" << endl;
    for(int i = x1; i <= x2; i++)
    {
    for(int j = y1; j <= y2; j++)
    cout << a[i][j];
    cout << endl;
    }

    cout << endl;

    return;*/
    lx = l1 = x2 - x1 + 1;
    ly = l2 = y2 - y1 + 1;

    int cmask = 0, need_mask = 0;
    for(int i = 0; i < l1; i++)
        for(int j = 0; j < l2; j++)
        {
            cmask |= ((a[i + x1][j + y1] == 'B') << get(i, j));
            need_mask |= ((t[i + x1][j + y1] == 'B') << get(i, j));
        }

    bfs(X - x1, Y - y1, cmask, need_mask);
    //cout << "here" << endl << flush
    X += x1;
    Y += y1;
}

void rec(int x1, int x2, int y1, int y2)
{
    int lxo = x2 - x1 + 1, lyo = y2 - y1 + 1;
    if(lxo <= 3 || lyo <= 3)
    {
        solve_brute(x1, x2, y1, y2);
        return;
    }

    int midx = (x1 + x2) >> 1, midy = (y1 + y2) >> 1;

    go_keep_color(x1, midy + 1);
    go_keep_color(midx + 1, midy + 1);
    go_keep_color(midx + 1, y1);

    go_keep_config(x1, y1);
    rec(x1, midx, y1, midy);

    go_keep_config(x1, midy + 1);
    rec(x1, midx, midy + 1, y2);

    go_keep_config(midx + 1, midy + 1);
    rec(midx + 1, x2, midy + 1, y2);

    go_keep_config(midx + 1, y1);
    rec(midx + 1, x2, y1, midy);

    go_keep_config(x1, y1);
}

void solve()
{
    for(int i = 0; i < n; i++)
    for(int j = 0; j < n; j++)
    a[i].push_back('W');
    a[0][0] = 'B';

    X = Y = 0;
    rec(0, n - 1, 0, n - 1);

    cout << ret << endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	read();
	solve();
	return 0;
}

