#include<iostream>
#include<stdio.h>
#include<algorithm>
#include<map>
#include<vector>
using namespace std ;

#define MAXN 100007

int n ;
pair < int , int > a[ MAXN ] ;


map < int , int > ZX ;
int MXVAL ;


class Tree {
	public :
	int tr[ 4 * MAXN ] ;
	int tm[ 4 * MAXN ] ;
	void init ( int where , int IL , int IR ) {
		tr[ where ] =  0 ;
		tm[ where ] = 1 ;
		if ( IL == IR ) { return ; }
		int mid = ( IL + IR ) / 2 ;
		init ( 2 * where , IL , mid ) ;
		init ( 2 * where + 1 , mid + 1 , IR ) ;
	}
	void combine ( int where ) {
		if ( tr[ 2 * where ] > tr[ 2 * where + 1 ] ) {
			tr[ where ] = tr[ 2 * where ] ;
			tm[ where ] = tm[ 2 * where ] ;	
		}
		else if ( tr[ 2 * where + 1 ] > tr[ 2 * where ] ) {
			tr[ where ] = tr[ 2 * where + 1 ] ;
			tm[ where ] = tm[ 2 * where + 1 ] ;
		}
		else {
			tr[ where ] = tr[ 2 * where ] ;
			tm[ where ] = ( tm[ 2 * where ] + tm[ 2 * where + 1 ] ) ;
		}
	}
	void update ( int where , int IL , int IR , int pos , int val ) {
		if ( IR < pos || pos < IL ) { return ; }
		if ( IL == IR ) {
			tr[ where ] += val ;
			return ;
		}
		int mid = ( IL + IR ) / 2 ;
		if ( pos <= mid ) { 
			update ( 2 * where , IL , mid , pos , val ) ;
		}
		else { 
			update ( 2 * where + 1 , mid + 1 , IR , pos , val ) ;
		}
		combine ( where ) ;
	}
};

Tree w ;


void compress ( ) {
	vector < int > srt ;
	int i ;
	for ( i = 1 ; i <= n ; i ++ ) {
		srt.push_back ( a[ i ].second ) ;
	}
	sort ( srt.begin ( ) , srt.end ( ) ) ;
	int id = 1 ;
	ZX[ srt[ 0 ] ] = 1 ;
	for ( i = 1 ; i < n ; i ++ ) {
		if ( srt[ i ] == srt[ i - 1 ] ) { continue ; }
		id ++ ;
		ZX[ srt[ i ] ] = id ;
	}
	for ( i = 1 ; i <= n ; i ++ ) {
		a[ i ].second = ZX[ a[ i ].second ] ;
	}
	MXVAL = id ;
	/**
	for ( i = 1 ; i <= n ; i ++ ) {
		printf ( "%d --> %d\n" , a[ i ].second , ZX[ a[ i ].second ] ) ;
	}
	**/
}

void input ( ) {
	scanf ( "%d" , &n ) ;
	int i ;
	for ( i = 1 ; i <= n ; i ++ ) {
		int x , y , z ;
		scanf ( "%d%d%d" , &x , &y , &z ) ;
		a[ i ].first = x - y ;
		a[ i ].second = x + z ;
	}
	sort ( a + 1 , a + n + 1 ) ;
	compress ( ) ;
	/**
	for ( i = 1 ; i <= n ; i ++ ) {
		printf ( "%d %d\n" , a[ i ].first , a[ i ].second ) ;
	}	
	**/
}


void solve ( ) {
	w.init ( 1 , 1 , MXVAL ) ;
	int i , j ;
	for ( i = 1 ; i <= n ; i ++ ) {
		w.update ( 1 , 1 , MXVAL , a[ i ].second , 1 ) ; 
	}
	long long ans1 , ans2 ;
	ans1 = ans2 = 0 ;
	for ( i = 1 ; i <= n ; i ++ ) {
		if ( i != 1 && a[ i ].first == a[ i - 1 ].first ) { continue ; }
		for ( j = i ; j <= n ; j ++ ) {
			if ( a[ j ].first != a[ i ].first ) { break ; }
			w.update ( 1 , 1 , MXVAL , a[ j ].second , -1 ) ;
		}
		int cur = ( j - i ) + w.tr[ 1 ] ;
		if ( cur > ans1 ) {
			ans1 = cur ;
			ans2 = 0 ;
		}
		if ( cur == ans1 ) {
			ans2 += w.tm[ 1 ] ;
		}
		for ( j = i ; j <= n ; j ++ ) {
			if ( a[ j ].first != a[ i ].first ) { break ; }
			w.update ( 1 , 1 , MXVAL , a[ j ].second , 1 ) ;
		}		
	}
	//cout << ans1 << " " << ans2 << "\n" ;
	printf ( "%d %lld\n" , ans1 , ans2 ) ;
}

int main ( ) { 
	input ( ) ;
	solve ( ) ;
	return 0 ;
}
