#include <set>
#include <algorithm>
#include <list>
#include "stations.h"
#define N 300001
using namespace std;
typedef long long ll;
ll n,k,d,ans;
struct St
{
    ll x,c,ind;
    St(){}
    St(ll x,ll c):x(x),c(c){}
} st[N];

set<St> s;
set<St>::iterator it,il,ir,i2;
list<St> l;

bool operator<(St a,St b)
{
    return a.x<b.x;
}

ll init(int dd,int kk,int nn,int pos[],int tax[])
{
    nn++;
    n=nn; d=dd; k=kk;
    for(int i=0; i<n-1; i++)
        st[i].x=pos[i], st[i].c=tax[i];
    st[n-1].x=d; st[n-1].c=0;
    sort(st,st+n);
    ll j=1,ans=0,gor=0;
    for(int i=0; i<n;)
    {
        s.insert(st[i]);
        if(i==n-1) break;
       // cout<<i<<" "<<gor<< endl;
        //cout<<j<<" "<<st[j].x<< endl;
        while(!l.empty() && l.front().x<=st[i].x) l.pop_front();

        int fl=1;
        while(j<n && st[j].x - st[i].x<=k)
        {
        //    cout<<i<<" "<<j<<" "<<st[i].c<<" "<<" "<<st[j].c<< endl;
            while(!l.empty() && l.back().c>st[j].c) s.erase(l.back()), l.pop_back();
            st[j].ind=j;
            l.push_back(st[j]);
            if(st[j].c<=st[i].c)
            {
                ans+=(st[j].x - gor)*st[i].c;
                fl=2;
                i=j;
                gor=st[i].x;
                j++;
                break;
            }
            j++;
        }
        if(fl==1)
        {
            if(j==n && st[i].x+k>=d)
                    ans+=(d-gor)*st[i].c, i=n;
            else
            {
                ans+=(st[i].x+k-gor)*st[i].c;
                gor=st[i].x+k;
                i=l.front().ind;
            }
        }
    }
    ::ans=ans;
    return ans;
}

ll addStation(int x,int c)
{
    St q(x,c);
    n++;
    s.insert(q);
    ll ans=0;
    list<St> l;
    set<St>::iterator i=s.begin(),j;
    j=i; j++;
    ll gor=0;
    //cout<<1<< endl;
    while(!l.empty()) l.pop_back();
    for(; i!=s.end();)
    {
        if(i->x==d) break;
      //  cout<<"i---"<<i->x<< endl;
        //cout<<i<<" "<<gor<< endl;
        //cout<<j<<" "<<st[j].x<< endl;
        while(!l.empty() && l.front().x<=i->x) l.pop_front();

        int fl=1;
        while(j!=s.end() && j->x - i->x<=k)
        {
        //    cout<<i<<" "<<j<<" "<<st[i].c<<" "<<" "<<st[j].c<< endl;
            while(!l.empty() && l.back().c>j->c) s.erase(l.back()) ,l.pop_back();
            //j->it=&j;
            l.push_back(*j);
            if(j->c<=i->c)
            {
                ans+=(j->x - gor)*i->c;
                fl=2;
                i=j;
                gor=i->x;
                j++;
                break;
            }
            j++;
        }
        if(fl==1)
        {
            if(j==s.end() && i->x+k>=d)
            {
                ans+=(d-gor)*i->c;
                break;
            }
            else
            {
                ans+=(i->x+k-gor)*i->c;
                gor=i->x+k;
               // cout<<gor<<" "<<l.front().x<< endl;
                i=s.find(l.front());
            }
        }
    }
    ::ans=ans;
    return ans;
    /*

    100 42 5
82 0 35 68 40
216 210 215 220 212
1
90 209
    */
{

  /*
    St q(x,c);
    it=s.insert(q).first;
    il=it--; ir=it++
    if(il->c >= ir->c)
        if(it->c < il->c)
            {
                ans-=(ir->x - it->x)*il->c;
                if(it->c >= ir->c )
                {
                    ans+=(ir->x - it->x)*it->c;
                }
                else
                {
                    i2=ir;
                    i2++;
                    while(1)
                    {
                        if(i2->x - it->x>k)
                        {
                            ans+=k*it->c;
                            ans-=(it->x+k - ir->x)*ir->c;
                            break;
                        }
                        if(ir->c > i2->c)
                        {
                            ans-=(i2->x - ir->x)*ir->c;
                            s.erase(ir);
                            if(i2->c <= it->c)
                            {
                                ans+=(i2->x-it->x)*it->c;
                                break;
                            }
                        }
                        else
                        {
                            ans+=k*it->c;
                            ans-=(it->x+k - ir->x)*ir->c;
                            break;
                        }
                        ir=i2;
                        i2++;
                    }
                }
            }
        else s.erase(it);
    else
    {
        if(it->c < ir->c)
            {
                ans-=(ir->x - it->x)*il->c;
                if(it->c <= il->c )
                {
                    ans-=k
                    ans+=(ir->x - it->x)*it->c;
                }
                else
                {
                    i2=ir;
                    i2++;
                    while(1)
                    {
                        if(i2->x - it->x>k)
                        {
                            ans+=k*it->c;
                            ans-=(it->x+k - ir->x)*ir->c;
                            break;
                        }
                        if(ir->c > i2->c)
                        {
                            ans-=(i2->x - ir->x)*ir->c;
                            s.erase(ir);
                            if(i2->c <= it->c)
                            {
                                ans+=(i2->x-it->x)*it->c;
                                break;
                            }
                        }
                        else
                        {
                            ans+=k*it->c;
                            ans-=(it->x+k - ir->x)*ir->c;
                            break;
                        }
                        ir=i2;
                        i2++;
                    }
                }
            }
        else s.erase(it);
    }
    return ans;
    */
}
}



/*
100 42 5
82 0 35 68 40
216 210 215 220 212
1
90 209
*/
