#include <iostream>
#include <cstdio>
#include <set>
#include <vector>
#include <algorithm>
using namespace std;

typedef long long Int;

const int MAXM=(6e5)+5;

vector < pair <Int,Int> > v;
vector < pair <Int,Int> > dp[MAXM];
bool fl;
int L,K,N;

Int init(int l,int k,int n,int pos[],int prices[])
{
 int i,j,z,ind,sz;
 Int dist,fuel,cost,ans,nc;
 set < pair <Int,Int> > :: iterator it,sit;

  for(i=0;i<n;i++)
  {
   v.push_back(make_pair(pos[i],prices[i]));

    if(pos[i]==l)
     fl=true;
  }

  if(!fl)
   v.push_back(make_pair(l,0));

 sort(v.begin(),v.end());

 dp[0].push_back(make_pair(0,0));
  for(i=0;i<v.size();i++)
   for(j=i+1;j<v.size();j++)
   {
    dist=v[j].first-v[i].first;

     if(dist>k)
      break;

     for(z=0;z<dp[i].size();z++)
     {
      fuel=dp[i][z].first;
      cost=dp[i][z].second;

       if(fuel>=dist)
        dp[j].push_back(make_pair(fuel-dist,cost));
       else
       {
        if(fuel+(dist-fuel)<=k)
        {
         nc=cost+((dist-fuel)*v[i].second);
         dp[j].push_back(make_pair(0,nc));
        }
       }

       nc=cost+((k-fuel)*v[i].second);
       dp[j].push_back(make_pair(k-dist,nc));
     }
   }

 sz=v.size();
 N=sz;
 L=l;
 K=k;
 ans=dp[sz-1][0].second;
  for(z=1;z<dp[sz-1].size();z++)
   ans=min(ans,dp[sz-1][z].second);

 return ans;
}

Int Solve()
{
 int i,j,z,ind,sz;
 Int dist,fuel,cost,ans,nc;
 set < pair <Int,Int> > :: iterator it,sit;

  for(i=0;i<N;i++)
   dp[i].clear();

 dp[0].push_back(make_pair(0,0));
  for(i=0;i<v.size();i++)
   for(j=i+1;j<v.size();j++)
   {
    dist=v[j].first-v[i].first;

     if(dist>K)
      break;

     for(z=0;z<dp[i].size();z++)
     {
      fuel=dp[i][z].first;
      cost=dp[i][z].second;

       if(fuel>=dist)
        dp[j].push_back(make_pair(fuel-dist,cost));
       else
       {
        if(fuel+(dist-fuel)<=K)
        {
         nc=cost+((dist-fuel)*v[i].second);
         dp[j].push_back(make_pair(0,nc));
        }
       }

       nc=cost+((K-fuel)*v[i].second);
       dp[j].push_back(make_pair(K-dist,nc));
     }
   }

 sz=v.size();
 ans=dp[sz-1][0].second;
  for(z=1;z<dp[sz-1].size();z++)
   ans=min(ans,dp[sz-1][z].second);

 return ans;
}

Int addStation(int newpos,int price)
{
 if(newpos==L)
  return Solve();

 v.push_back(make_pair(newpos,price));
 sort(v.begin(),v.end());
 N++;
 return Solve();
}
