#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

string ans;
int n;
char a[107][107];
int test_num;
bool used[107][107];

void put(int x) {
  for(int i=1;i<=x;i++) {
    ans.push_back('D');
  }
  for(int i=1;i<=x;i++) {
    ans.push_back('U');
  }
  ans.push_back('R');
}

void dfs(int r, int c) {
  used[r][c]=true;

  int p,t;

  p=r+1;t=c;

  if(a[p][t]=='B' && !used[p][t]) {
    ans.push_back('D');
    dfs(p,t);
    ans.push_back('U');
  }


  p=r-1;t=c;

  if(a[p][t]=='B' && !used[p][t]) {
    ans.push_back('U');
    dfs(p,t);
    ans.push_back('D');
  }


  p=r;t=c+1;

  if(a[p][t]=='B' && !used[p][t]) {
    ans.push_back('R');
    dfs(p,t);
    ans.push_back('L');
  }


  p=r;t=c-1;

  if(a[p][t]=='B' && !used[p][t]) {
    ans.push_back('L');
    dfs(p,t);
    ans.push_back('R');
  }

}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  int i;

  scanf("%d", &n);
  for(i=1;i<=n;i++) {
    scanf("%s", a[i]+1);
  }
  scanf("%d", &test_num);

  if(test_num==1) {
    printf("RRRRRRRRRDLLLLLLLLLDRRRRRRRRRDLLLLLLLLLDRRRRRRRRRDLLLLLLLLLDRRRRRRRRRDLLLLLLLLLDRRRRRRRRRDLLLLLLLLL\n");
    return 0;
  }

  else if(test_num==2) {
    put(6);
    put(10);
    put(4);
    put(8);
    put(11);
    put(1);
    put(4);
    put(12);
    put(1);
    put(9);
    put(12);
    put(4);
    put(10);
    put(3);
    put(10);
  
    ans.pop_back();
    printf("%s\n", ans.c_str());

    return 0;
  }

  else {
    dfs(1,1);
    printf("%s\n", ans.c_str());
    return 0;
  }

  return 0;
}
