#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

map< pair< int64_t, int64_t >, int64_t > cntPairs;
unordered_map< int64_t, int64_t > cntSingles;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int64_t n;
	cin >> n;
	
	set< int64_t > allPoints;
	for(int64_t i = 0; i < n; i++) {
		int64_t p, w, e;
		cin >> p >> w >> e;

		pair< int64_t, int64_t > curr = { p - w, p + e };
		
		cntPairs[curr]++;
		cntSingles[p - w]++;
		cntSingles[p + e]++;

		allPoints.insert(p - w);
		allPoints.insert(p + e);
	}

	vector< int64_t > v((int64_t) allPoints.size());
	for(auto &x : allPoints) {
		v.push_back(x);
	}

	int64_t maxCnt = 0, cntWithMaxCnt;
	for(int64_t i = 0; i < (int64_t) v.size(); i++) {
		for(int64_t j = i + 1; j < (int64_t) v.size(); j++) {
			pair< int64_t, int64_t > p = { v[i], v[j] };

			int64_t currCnt = cntSingles[v[i]] + cntSingles[v[j]] - cntPairs[p];

			if(currCnt > maxCnt) {
				maxCnt = currCnt;
				cntWithMaxCnt = 1;
			}
			else if(currCnt == maxCnt) {
				cntWithMaxCnt++;
			}
		}
	}

	cout << maxCnt << " " << cntWithMaxCnt << endl;
}
