#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int32_t MAX_N = 1e5;

map< pair< int32_t, int32_t >, int32_t > cntPairs;
map< pair< int32_t, int32_t >, bool > haveCounted;
map< int32_t, int32_t > cntSingles;

pair< int32_t, int32_t > pairs[MAX_N + 5];

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int32_t n;
	cin >> n;

	set< int32_t > allPoints; 
	for(int32_t i = 0; i < n; i++) {
		int32_t p, e, w;
		cin >> p >> w >> e;

		pairs[i] = { p - w, p + e };
		
		cntSingles[p - w]++;
		cntSingles[p + e]++;
		cntPairs[pairs[i]]++;
		
		allPoints.insert(p - w);
		allPoints.insert(p + e);
	}
	
	int32_t maxAns = 0, ansCnt = 0;
	for(int32_t i = 0; i < n; i++) {
		int32_t currAns = cntSingles[pairs[i].first] + cntSingles[pairs[i].second] - cntPairs[pairs[i]];
		
		if(haveCounted[pairs[i]]) {
			continue;
		}

		haveCounted[pairs[i]] = true;

		if(currAns > maxAns) {
			maxAns = currAns;
			ansCnt = 1;
		}
		else if(currAns == maxAns) {
			ansCnt++;
		}
	}

	cout << maxAns << " " << ansCnt << endl;
}
