#include<iostream>
#include<algorithm>
#include<queue>
#include<vector>
#define MAX 10000
using namespace std;
int n,br=0;
struct sign
{
    int p;
    int e;
    int w;
};
struct point
{
    int x,broj;
    point(int a, int b)
    {
        x=a;
        broj=b;
    }
    bool operator<(const point &o) const
    {
        return broj<o.broj;
    }
};




int x[MAX];
int used[MAX];
int cross[MAX][MAX];
int main()
{
    ios::sync_with_stdio(0);
    cin.tie();
    cin>>n;
    priority_queue <point> pq;
    vector <point> v;
    for (int a=0; a<n; a++)
    {
        int pt,e,w;
        cin>>pt>>w>>e;
        x[pt-w+MAX/2]++;
        x[pt+e+MAX/2]++;
        cross[pt-w+MAX/2][pt+e+MAX/2]++;
        cross[pt+e+MAX/2][pt-w+MAX/2]++;
        pq.push(point(pt-w+MAX/2,x[pt-w+MAX/2]));
        pq.push(point(pt+e+MAX/2,x[pt+e+MAX/2]));
    }
    int best=0;
    int brBest=0;
    while(!pq.empty())
    {
        int k=pq.top().x;
        if(used[k])
        {
            pq.pop();
            continue;
        }
        v.push_back(pq.top());
        used[k]=1;
        pq.pop();
    }


    for(int a=0; a<v.size(); a++)
    {
        for(int b=a+1; b<v.size(); b++)
        {
            if(v[a].broj+v[b].broj<best)
                break;
            if(best<v[a].broj+v[b].broj-cross[v[a].x][v[b].x])
            {
                best=v[a].broj+v[b].broj-cross[v[a].x][v[b].x];
                brBest=1;
            }
            else if(best==v[a].broj+v[b].broj-cross[v[a].x][v[b].x])
            {
                brBest++;
            }
        }
    }
    cout<<best<<" "<<brBest<<endl;
    return 0;
}


/**
11
-17 10 19
-8 2 50
-2 11 3
0 13 42
3 2 6
7 33 15
11 10 31
12 25 4
13 10 7
14 10 10
17 16 25


24
-10 9 1
-9 20 10
-8 1 11
-7 12 17
-6 20 16
-5 22 13
-4 30 6
-3 20 7
-2 25 16
-1 3 21
0 30 7
1 17 22
2 9 5
3 25 18
4 21 13
5 16 17
6 4 5
7 15 8
8 11 24
9 26 3
10 25 14
11 2 21
12 22 5
13 24 17
*/
