#include<iostream>
#include<cmath>
#include<algorithm>
#include<queue>
#include<vector>
#define MAX 2000000
#define MAXK 30000
using namespace std;
int n,br=0;

struct tochka
{
    int x,y;
};

bool cmp(tochka a, tochka b)
{
    if(a.x==b.x)
        return a.y<b.y;
    return a.x<b.x;
}


struct point
{
    int x,broj,type;
    point(int a, int b)
    {
        x=a;
        broj=b;
    }
    bool operator<(const point &o) const
    {
        return broj<o.broj;
    }
};



tochka t[100000];
int x[MAX];
short used[MAX];
short small[MAX];
short kros[MAXK][MAXK];
int bs(int beg, int end, int key)
{
    int mid=beg+end;
    mid/=2;
    ///cout<<beg<<" "<<end<<" "<<t[mid].x<<endl;
    if(end==0)return -1;
    if(beg==br-1)return -1;
    if(beg==end)return -1;
    if(t[mid].x==key)return mid;
    else if(t[mid].x<key)return bs(mid,end,key);
    else if(t[mid].x>key)return bs(beg,mid,key);
}
int main()
{
    bool fls=false;
    ios::sync_with_stdio(0);
    cin.tie();
    cin>>n;
    priority_queue <point> pq;
    vector <point> v;
    int br=0;
    int big=0;

    for (int a=0; a<n; a++)
    {
        int pt,e,w;
        cin>>pt>>w>>e;
        t[br].x=pt-w+MAX/2;
        t[br].y=pt+e+MAX/2;
        if(t[br].x>t[br].y)
            swap(t[br].x,t[br].y);
        small[t[br].x]=1;
        br++;
        x[pt-w+MAX/2]++;
        x[pt+e+MAX/2]++;
        big=max(big,abs(pt-w+MAXK/2));
        big=max(big,abs(pt+e+MAXK/2));
        if(big>25000)
            fls=true;

        if(fls==false)
        {
            kros[pt-w+MAXK/2][pt+e+MAXK/2]++;
            kros[pt+e+MAXK/2][pt-w+MAXK/2]++;
        }
        pq.push(point(pt-w+MAX/2,x[pt-w+MAX/2]));
        pq.push(point(pt+e+MAX/2,x[pt+e+MAX/2]));
    }


    int best=0;
    int brBest=0;

    while(!pq.empty())
    {
        int k=pq.top().x;
        if(used[k])
        {
            pq.pop();
            continue;
        }
        v.push_back(pq.top());
        used[k]=1;
        pq.pop();
    }
    sort(t,t+br,cmp);


    if(fls==true)
    {
        for(int a=0; a<v.size(); a++)
        {
            for(int b=a+1; b<v.size(); b++)
            {
                if(v[a].broj+v[b].broj<best)
                    break;
                int k=v[a].x;
                int j=v[b].x;

                if(k>j)swap(k,j);
                int cross=0;
                if(small[k]==1 || small[j]==1)
                {
                    int pos;
                    if(small[k]==1)
                        pos=bs(0,br-1,k);
                    else pos=bs(0,br-1,j);

                    int c=pos;

                    while(c>=0 && t[c].x==k)
                    {
                        if(t[c].y==j)cross++;
                        c--;
                    }
                    c=pos+1;
                    while(c>=0 && c<br && t[c].x==k)
                    {
                        if(t[c].y==j)cross++;
                        c++;
                    }
                }
                if(best<v[a].broj+v[b].broj-cross)
                {
                    best=v[a].broj+v[b].broj-cross;
                    brBest=1;
                }
                else if(best==v[a].broj+v[b].broj-cross)
                {
                    brBest++;
                }
            }
        }
    }
    else
    {
        for(int a=0; a<v.size(); a++)
        {
            for(int b=a+1; b<v.size(); b++)
            {
                if(v[a].broj+v[b].broj<best)
                    break;
                int x1,x2;
                x1=v[a].x-MAX/2+MAXK/2;
                x2=v[b].x-MAX/2+MAXK/2;
                if(best<v[a].broj+v[b].broj-kros[x1][x2])
                {
                    best=v[a].broj+v[b].broj-kros[x1][x2];
                    brBest=1;
                }
                else if(best==v[a].broj+v[b].broj-kros[x1][x2])
                {
                    brBest++;
                }
            }
        }
    }
    cout<<best<<" "<<brBest<<endl;
    return 0;
}


/**
11
-17 10 19
-8 2 50
-2 11 3
0 13 42
3 2 6
7 33 15
11 10 31
12 25 4
13 10 7
14 10 10
17 16 25


24
-10 9 1
-9 20 10
-8 1 11
-7 12 17
-6 20 16
-5 22 13
-4 30 6
-3 20 7
-2 25 16
-1 3 21
0 30 7
1 17 22
2 9 5
3 25 18
4 21 13
5 16 17
6 4 5
7 15 8
8 11 24
9 26 3
10 25 14
11 2 21
12 22 5
13 24 17
*/
